#ifndef RVG_BBOX_H
#define RVG_BBOX_H

#include "math/point.h"

namespace rvg {

template <class T>
struct BBox {
    BBox(T xmin, T ymin, T xmax, T ymax): min{xmin, ymin}, max{xmax, ymax} {}
    math::euclidean::Point<T,2> min, max;
};

using Viewport = BBox<int>;
using Window = BBox<float>;

}

#endif
