#ifndef NLFILTER_IMAGE_UTIL_H
#define NLFILTER_IMAGE_UTIL_H

#include "vector.h"
#include "image.h"

namespace gpu
{

template <class T>
void compose(image_ptr<T> &out,
             const image<float> &r, const image<float> &g,
             const image<float> &b);

template <class T>
void compose(image_ptr<T> &out,
             const image<float> &r, const image<float> &g,
             const image<float> &b, const image<float> &a);


template <class T, int N>
void decompose(vector<float> out[N], const vector<T> &in,
               int width, int height, int rowstride);

template <class T>
void grayscale(vector<float> &out, const vector<T> &in,
               int width, int height, int rowstride);

}

#endif
