#ifndef GPU_SORT_H
#define GPU_SORT_H

#include "util.h"
#include "iterator.h"

namespace gpu
{

// basic insertion sort
template <class IT>
__device__ void sort(IT beg, IT end)
{
    typedef typename IT::value_type T;

    int n = distance(beg, end);
    if(n <= 1)
        return;

    if(n == 2)
    {
        T &a = *beg,
          &b = *next(beg);

        if(b < a)
            swap(a,b);
        return;
    }
    for(IT cur = next(beg); cur != end; ++cur)
    {
        T value = *cur;
        IT pos;
        for(pos = cur; pos != beg; --pos)
        {
            T &v = *prev(pos);
            if(v <= value)
                break;
            *pos = v;
        }
        *pos = value;
    }
}

}

#endif
