#include <stdexcept>
#include <iostream>

namespace rod
{

namespace
{
    void print_level(std::ostream &out, const std::exception &e, int level)
    {
        out << std::string(level, ' ') << e.what() << std::endl;

        try
        {
            rethrow_if_nested(e);
        }
        catch(std::exception &e)
        {
            print_level(out, e, level+1);
        }
    }
}

void print_exception(std::ostream &out, const std::exception &e)
{
    print_level(out, e, 0);
}

} // namespace rod
