#ifndef GPU_UTIL_FORMAT_H
#define GPU_UTIL_FORMAT_H

#include <sstream>

namespace rod
{

std::ostream &format_aux(std::ostream &out)
{
    return out;
}

template <class T, class...ARGS>
std::ostream &format_aux(std::ostream &out, const T &arg0, ARGS &&...args)
{
    out << arg0;
    return format_aux(out, std::forward<ARGS>(args)...);
}

template <class...ARGS>
std::string format(ARGS &&...args)
{
    std::ostringstream ss;
    format_aux(ss, std::forward<ARGS>(args)...);
    return ss.str();
}

} // namespace rod

#endif
