#ifndef GPUMORPH_CURVE1_H
#define GPUMORPH_CURVE1_H

#include <gpu/cutil.h>
#include "curve.h"

__device__ inline float2 eval(const Curve<1> &B, float t)
{
    return (1-t)*B[0] + t*B[1];
}

__device__ inline Curve<1> subcurve(const Curve<1> &B, float u, float v)
{
    Curve<1> out;
    out[0] = lerp(B[0], B[1], u);
    out[1] = lerp(B[0], B[1], v);

    return out;
}

#endif
