#ifndef GPURASTER_CURVE2_H
#define GPURASTER_CURVE2_H

#include <gpu/solve.h>
#include <gpu/cutil.h>
#include "curve.h"

__device__ inline float2 eval(const Curve<2> &B, float t)
{
    return lerp(lerp(B[0],B[1],t), lerp(B[1],B[2],t), t);
}

__device__ inline float2 blossom(const Curve<2> &B, float u, float v)
{
    return B[0]*(u*v - u - v+1) + B[1]*(u + v - 2*u*v) + B[2]*(u*v);
}

__device__ inline Curve<2> subcurve(const Curve<2> &seg, float u, float v)
{
    Curve<2> out;
    if(u == 0)
    {
        out[0] = seg[0];
        out[1] = blossom(seg, u, v);
        out[2] = blossom(seg, v, v);
    }
    else if(v == 1)
    {
        out[0] = blossom(seg, u, u);
        out[1] = blossom(seg, u, v);
        out[2] = seg[2];
    }
    else
    {
        out[0] = blossom(seg, u, u);
        out[1] = blossom(seg, u, v);
        out[2] = blossom(seg, v, v);
    }

    return out;
}

#endif
