#ifndef GPURASTER_IMPLICITIZE1_CUH
#define GPURASTER_IMPLICITIZE1_CUH

#include <gpu/linalg.h>
#include "icurve1.h"

template <int N>
struct __align__(8) ImplicitizationContext
{
    // default, doesn't need any context
};



__device__ void implicitize(const Curve<1> &B,
                            ImplicitCurve<1> &iB,
                            float t0, float t1,
                            const ImplicitizationContext<1> &ctx)
{
    assert(iB.flags == 0);

    iB.bbox = get_xy_mono_bbox(B);
    if(B[0].x < B[1].x)
        iB.flags |= CFLAG_GOING_RIGHT;
    if(B[0].y < B[1].y)
        iB.flags |= CFLAG_GOING_UP;

    // allways true!!!
    iB.flags |= CFLAG_GEOM_TO_LEFT;

    if(iB.going_up() != iB.geom_to_left())
        iB.flags |= CFLAG_OUT_IS_LEFT;


}

#endif
