#ifndef GPURASTER_PATHDATA_H
#define GPURASTER_PATHDATA_H

enum FillRule
{
    FRULE_ODD,
    FRULE_EVEN,
    FRULE_NONZERO,
    FRULE_ZERO
};

class Paint;

struct PathData
{
    const Paint *paint;
    int idpath;
    int idquad;
    FillRule frule;
    int paint_type;

    __device__ bool intersects(int isects) const
    {
        switch(frule)
        {
        case FRULE_ODD:
            return isects & 1;
        case FRULE_EVEN:
            return (isects & 1) == 0;
        case FRULE_NONZERO:
            return isects != 0;
        case FRULE_ZERO:
            return isects == 0;
        default:
            assert(false);
            return false;
        }
    }
};

#endif
