#include "raster.h"
#include "raster_warp.hpp"

template<>
void rasterize_warp(const NoWarp& nowarp, const float4 &bg_color,
               const Quads &qtree,
               const Segments &segs,
               unsigned nsamples,
               gpu::image_ptr<float4> out,
               unsigned flags,
               unsigned use_bs3)
{
    //std::cerr << "raster no warp" << std::endl;
    rasterize_warp_template( nowarp, bg_color, qtree, segs, nsamples, out, flags, use_bs3 );
}

template<>
void rasterize_warp(const ProjectiveWarp& fs, const float4 &bg_color,
               const Quads &qtree,
               const Segments &segs,
               unsigned nsamples,
               gpu::image_ptr<float4> out,
               unsigned flags,
               unsigned use_bs3)
{
    //std::cerr << "raster projective warp" << std::endl;
    rasterize_warp_template( fs, bg_color, qtree, segs, nsamples, out, flags, use_bs3 );
}

template<>
void rasterize_warp(const LensWarp& lens, const float4 &bg_color,
               const Quads &qtree,
               const Segments &segs,
               unsigned nsamples,
               gpu::image_ptr<float4> out,
               unsigned flags,
               unsigned use_bs3)
{
    //std::cerr << "raster lens warp" << std::endl;
    rasterize_warp_template( lens, bg_color, qtree, segs, nsamples, out, flags, use_bs3 );
}

template<>
void rasterize_warp(const SwirlWarp& swirl, const float4 &bg_color,
               const Quads &qtree,
               const Segments &segs,
               unsigned nsamples,
               gpu::image_ptr<float4> out,
               unsigned flags,
               unsigned use_bs3)
{
    //std::cerr << "raster swirl warp" << std::endl;
    rasterize_warp_template( swirl, bg_color, qtree, segs, nsamples, out, flags, use_bs3 );
}
