#ifndef _CALLBACK_H
#define _CALLBACK_H

#include <lua.hpp>

class LuaCallback {
    public:
    LuaCallback( lua_State* L, int index )
        : m_L(L), m_index(index)
    { ; }

    void operator()(void) {
        lua_rawgeti(m_L, LUA_REGISTRYINDEX, m_index);
        if ( lua_pcall(m_L, 0, 0, 0) == 0 ) {
            std::cerr << "error: " << lua_tostring(m_L,-1) << std::endl;
        }
    }

    void operator()( int key ) {
        lua_rawgeti(m_L, LUA_REGISTRYINDEX, m_index);
        lua_pushnumber(m_L, key);
        if ( lua_pcall(m_L, 1, 0, 0) == 0 ) {
            std::cerr << "error: " << lua_tostring(m_L,-1) << std::endl;
        }
    }

    void operator()( int button, int state, int x, int y ) {
        lua_rawgeti(m_L, LUA_REGISTRYINDEX, m_index);
        lua_pushnumber(m_L, button);
        lua_pushnumber(m_L, state);
        lua_pushnumber(m_L, x);
        lua_pushnumber(m_L, y);
        if ( lua_pcall(m_L, 4, 0, 0) == 0 ) {
            std::cerr << "error: " << lua_tostring(m_L,-1) << std::endl;
        }
    }

    void operator()( int x, int y ) {
        lua_rawgeti(m_L, LUA_REGISTRYINDEX, m_index);
        lua_pushnumber(m_L, x);
        lua_pushnumber(m_L, y);
        if ( lua_pcall(m_L, 2, 0, 0) == 0 ) {
            std::cerr << "error: " << lua_tostring(m_L,-1) << std::endl;
        }
    }

    private:
    lua_State* m_L;
    int m_index;
};

#endif
