#ifndef RVG_IMAGE_PNG_H
#define RVG_IMAGE_PNG_H

#include <string> 
#include "base.h"

namespace rvg { namespace image { namespace png {
    // for png comments
    void free_text(void);
    void init_text(int argc, char **argv);
    void push_text(const char *key, const char *text);
    void pop_text(int n = 1);
    // load and store
    int load(FILE *file, Base &rgba);
    int load(const std::string &memory, Base &rgba);
    int store(FILE *file, const Base &rgba);
    int store(std::string &memory, const Base &rgba);
    // output in 8-bit per channel
    int store8(FILE *file, const Base &rgba);
    int store8(std::string &memory, const Base &rgba);

} } }

#endif // RVG_IMAGE_PNG_H
