#ifndef RVG_LUA_CUDA_H
#define RVG_LUA_CUDA_H

#include "../driver/cuda.h"
#include "base.h"

namespace rvg { namespace lua {

class CUDA: public Base {
public:
    virtual ~CUDA() {}
protected:
    virtual void do_open(lua_State *L) override;
    virtual void do_close(lua_State *L) override;
    driver::Base *do_driver(void) override { return &m_cuda; }
    const driver::Base *do_driver(void) const override { return &m_cuda; }
private:
    driver::CUDA m_cuda;
};

}}

#endif // RVG_LUA_CUDA_H
