#ifndef RVG_MATH_PROJECTIVE_FWD_H
#define RVG_MATH_PROJECTIVE_FWD_H

namespace rvg { namespace math
{

namespace projective
{
    template <class T, int N>
    struct Point;

    template <int N>
    using Pointf = Point<float,N>;

    template <int N>
    using Pointi = Point<int,N>;

    template <int N>
    using Pointd = Point<double,N>;
}

// P^2 types

namespace p2
{
    using Pointf = projective::Pointf<2>;
    using Pointi = projective::Pointi<2>;
    using Pointd = projective::Pointd<2>;
    using Point = projective::Pointf<2>;
}

} // namespace math

namespace p2 = math::p2;

} // namespace rvg

#endif
