#ifndef RVG_SVD_H
#define RVG_SVD_H

#include "../xform/xform.h"

namespace rvg { namespace math {

// analytic singular value decomposition of 2D matrix
// if you only care about U and S
void svd(const xform::Linear &A, xform::Rotation &U, xform::Scale &S);

// analytic singular value decomposition of 2D matrix
// if you care about U, S and V
void svd(const xform::Linear &A, xform::Rotation &U,
    xform::Scale &S, xform::Linear &V);

}} // rvg::math

#endif
