namespace rvg { namespace paint {

template <class T>
T &BaseHelper<T>::derived()
{
    return static_cast<T &>(*this);
}

template <class T>
const T &BaseHelper<T>::derived() const
{
    return static_cast<const T &>(*this);
}

template <class T>
void BaseHelper<T>::accept(Visitor &v) const
{
    // gcc will devirtualize this call
    // if this function was reached through
    // non-virtual call due to previous
    // compiler devirtualization
    v.visit(derived());
}

template <class T>
Base *BaseHelper<T>::do_clone() const
{
    return new T(derived());
}

}} // namespace rvg::paint
