#ifndef RVG_PAINT_LINEAR_GRADIENT_H
#define RVG_PAINT_LINEAR_GRADIENT_H

#include "../constants.h"
#include "xformedbase.h"
#include "ramp.h"

namespace rvg { namespace paint {

class LinearGradient: public XFormedBase<LinearGradient> {
public:
    static constexpr const PaintType paint_type = PaintType::linear_gradient;
    LinearGradient(
        const ramp::Ramp &ramp,
        r2::Point p1, r2::Point p2,
        const Transform &xf = Transform{}):
        XFormedBase(xf),
        m_ramp(ramp),
        m_p1(p1),
        m_p2(p2) {}

    const r2::Point p1(void) const { return m_p1; }
    const r2::Point p2(void) const { return m_p2; }
    const ramp::Ramp &ramp(void) const { return m_ramp; }

    IMPLEMENT_PAINT_XFORMEDBASE(LinearGradient);
protected:
    virtual void do_print(std::ostream &out) const;
private:
    ramp::Ramp m_ramp;
    r2::Point m_p1, m_p2;
};

}} // namespace rvg::paint

#endif // RVG_PAINT_LINEAR_GRADIENT_H
