#ifndef RVG_PAINT_SOLID_H
#define RVG_PAINT_SOLID_H

#include "../color.h"
#include "../constants.h"
#include "base.h"

namespace rvg { namespace paint {

class Solid final: public BaseHelper<Solid> {
public:
    static constexpr const PaintType paint_type = PaintType::solid;
    Solid(const Color &color): m_color(color) {}
    const Color &color(void) const { return m_color; }
protected:
    virtual Solid &do_transform(const Transform &) { return *this; }
    virtual void do_print(std::ostream &out) const;
private:
    Color m_color;
};

}} // namespace rvg::paint

#endif // RVG_PAINT_SOLID_H
