#ifndef RVG_PAINT_TEXTURE_H
#define RVG_PAINT_TEXTURE_H

#include "../constants.h"
#include "../image/image.h"
#include "xformedbase.h"

namespace rvg { namespace paint {

class Texture final: public XFormedBase<Texture> {
public:
    static constexpr const PaintType paint_type = PaintType::texture;

    Texture(Image image, SpreadMethod spread_method,
        const Transform &xf = Transform{}):
        XFormedBase(xf), m_image(image), m_spread_method(spread_method) {}

    const Image &image(void) const { return m_image; }
    SpreadMethod spread(void) const { return m_spread_method; }

    IMPLEMENT_PAINT_XFORMEDBASE(Texture);
protected:
    virtual void do_print(std::ostream &out) const;
private:
    Image m_image;
    SpreadMethod m_spread_method;
};

}} // namespace rvg::paint

#endif // RVG_PAINT_TEXTURE_H
