#ifndef RVG_PAINT_VISITOR_H
#define RVG_PAINT_VISITOR_H

#include "fwd.h"

namespace rvg { namespace paint {

class Visitor {
public:
    template <class T>
    void visit(const T &xf) { do_visit(xf); }
private:
    virtual void do_visit(const Solid &solid) = 0;
    virtual void do_visit(const LinearGradient &linear) = 0;
    virtual void do_visit(const RadialGradient &radial) = 0;
    virtual void do_visit(const Texture &texture) = 0;
};

}} // namespace rvg::paint

#endif // RVG_PAINT_VISITOR_H
