/* this should be in the utilities include file */
typedef enum _qvgu_adjustment {
    QVGU_ADJUST_WIDTH,  /* match window width, adjust height */
    QVGU_ADJUST_HEIGHT, /* match window height, adjust width */
    QVGU_ADJUST_PAD,    /* pad window so it fits entirely in viewport */
    QVGU_ADJUST_CROP,   /* crop window so viewport fits entirely in window */
    QVGU_ADJUST_CENTER, /* center other dimension */
    QVGU_ADJUST_LOWER,  /* lower other dimension */
    QVGU_ADJUST_RAISE,  /* raise other dimension */
} qvg_adjustment;

/* adjust a window to avoid distortions when mapped to a viewport
 * this should be in the utilities include */
void qvgu_adjust_window(float *wx0, float *wy0, float *wx1, float *wy1,
    int vx0, int vy0, int vx1, int vy1, qvgu_adjustment matched,
    qvgu_adjustment other);
