#ifndef RVG_RENDERSETTINGS_H
#define RVG_RENDERSETTINGS_H

#include "constants.h"

namespace rvg {

struct RenderSettings {
    RenderSettings(PrefilterKernel prefilter_kernel,
        SamplingRate sampling_rate, SamplingPattern sampling_pattern,
        SpreadMethod spread_method, BlendMode blend_mode):
        prefilter_kernel(prefilter_kernel), sampling_rate(sampling_rate),
        sampling_pattern(sampling_pattern), spread_method(spread_method),
        blend_mode(blend_mode) {}

    PrefilterKernel prefilter_kernel;
    SamplingRate sampling_rate;
    SamplingPattern sampling_pattern;
    SpreadMethod spread_method;
    BlendMode blend_mode;
};

}

#endif
