#include <iostream>
#include "style.h"

namespace rvg { namespace stroke {

std::ostream &operator<<(std::ostream &out, const Style &style) {
    out << "stroke style width " << style.width << " [ ";
    for (auto v: style.dash.array)
        out << v << ' ';
    out << "]:" << style.dash.initial_phase << ":" << style.dash.phase_reset
        << ' ' << style.cap << ' ' << style.join;
    if (style.join == JoinStyle::miter)
        out << '(' << style.miter_limit << ')';
    return out;
}

}} // namespace rvg::stroke
