#ifndef RVG_STROKE_STYLE_H
#define RVG_STROKE_STYLE_H

#include <vector>

#include "../constants.h"

namespace rvg { namespace stroke {

struct Dash {
    std::vector<float> array;
    float initial_phase;
    bool phase_reset;
};

struct Style {
    // allow automatic conversion from float
    Style(float width = 1.f):
        width(width),
        cap(CapStyle::butt),
        join(JoinStyle::miter), miter_limit(4.f),
        dash{{}, 0.f, false} { }
    float width;
    CapStyle cap;
    JoinStyle join;
    float miter_limit;
    Dash dash;
};

std::ostream &operator<<(std::ostream &out, const Style &style);

}} // namespace rvg::stroke

#endif // RVG_STROKE_STYLE_H
