local svg=require"rvg10.svg"
setmetatable(_G, { __index = svg} )

local w = 512
local sw = 30
local d = 3*sw
local n = 60

local c = math.cos(math.pi/4)
local p = path{M, 0,w, L, 0,0, w/10,w/2, 3*w/10,0, 6*w/10,w/2, w,0, R, w*c,w*c,c, 0,w, Z}

q = p:scale(-1,1):translate(2*w+sw,0):append(p)

for i = 1, n do
    local r = q:stroke{
      width = sw,
      cap = cap.triangle,
      join = join.round,
      miter_limit = 1.1,
      dash = {d, d; initial_phase = 3*d*i/n, phase_reset = true}
    }
    f = io.open(string.format("a-%02d.svg", i), "w")
    local s = scene{fill(r, color.black)}
    render(s, viewport(-sw,-sw,2*(w+sw),w+sw), f)
    f:close()
end
