set(output_file "${BINARY_DIR}/out/${TEST_NAME}.out")
set(diff_file "${BINARY_DIR}/${TEST_NAME}.diff")
set(expected_file "${SOURCE_DIR}/exp/${TEST_NAME}.out")

execute_process(COMMAND /bin/bash -c "${TEST_EXEC} ${TEST_NAME} > ${output_file} 2>&1"
    RESULT_VARIABLE HAD_ERROR)

if(HAD_ERROR)
    message(FATAL_ERROR "Test failed: ${HAD_ERROR}")
endif()

execute_process(COMMAND ${CMAKE_COMMAND} -E compare_files
    "${output_file}" "${expected_file}"
    RESULT_VARIABLE DIFFERENT)

if(DIFFERENT)
    execute_process(COMMAND diff -N "${expected_file}" "${output_file}"
                    OUTPUT_FILE "${diff_file}")
    message(FATAL_ERROR "Test failed - output differ")
endif()
                
