#include <iostream>
#include "../path/arc.h"
#include "../math/util.h"

using namespace rvg;

std::ostream &operator<<(std::ostream &out, const path::VGArc &vg) {
    out <<  "p0: "  << vg.p0() 
        << " p2: "  << vg.p2() 
        << " rx: "  << vg.rx() 
        << " ry: "  << vg.ry() 
        << " ang: " << vg.ang()*math::to_deg()
        << " fa: "  << vg.fa() 
        << " fs: "  << vg.fs();
    return out;
}

int main(void) {
#if 0
    r2::Point p0{3.f/5.f, 4.f/5.f}, p2{3.f/5.f, -4.f/5.f};
    float w = 2, h = 1;
    float ang = 35.f*math::to_rad();
    float c = cos(ang), s = sin(ang);
    bool fa = false, fs = true;
    path::VGArc vgarc(p0, w, h, c, s, fa, fs, p2);
    std::cout << vgarc << std::endl;
    path::RationalArc rarc(p0, w, h, c, s, fa, fs, p2);
    std::cout <<  "p0: " << rarc.p0() 
              << " p1: " << rarc.p1() 
              << " p2: " << rarc.p2() << std::endl; 
    path::VGArc vgarc2 = static_cast<path::VGArc>(rarc);
    std::cout << vgarc2 << std::endl;
#endif

    path::RationalArc rarc1(r2::Point{2.5f,1.f}, r3::Point{1.f,0.f,0.f}, r2::Point{2.5f,-1.f});
    std::cerr << static_cast<path::VGArc>(rarc1) << '\n';
    path::RationalArc rarc2(r2::Point{2.5f,1.f}, r3::Point{-1.f,0.f,0.f}, r2::Point{2.5f,-1.f});
    std::cerr << static_cast<path::VGArc>(rarc2) << '\n';
    return 0;
}
