#include <iostream>

#include "../driver/cpu.h"
#include "../math/util.h"

namespace input {
#include "../inputs/drops.h"
}

//namespace input {
//#include "../inputs/tiger.h"
//}

//namespace input {
//#include "../inputs/lion.h"
//}


rvg::Scene gradscene(rvg::driver::Base &drv) {
  using namespace rvg;
  using Point = r2::Point;
  using Affine = xform::Affine;
  CommandType L = CommandType::line_to_abs;
  CommandType M = CommandType::move_to_abs;
  CommandType Q = CommandType::quad_to_abs;
  CommandType C = CommandType::cubic_to_abs;
  (void) L; (void) M; (void) Q; (void) C;
  Scene fdscene = drv.new_scene();
  auto fdpath = drv.new_path({
    {M,0,0},
    {L,1,0},
    {L,1,1},
    {L,0,1},
    {L,0,0}});
  auto fdpaint = drv.new_linear_gradient(drv.new_color_ramp(SpreadMethod::pad,{
    {0,1,0,0,1},
    {1,0,0,1,1}}),
    Point{0,0},Point{0,1},xform::Affine{1, 0, 0, 1, 1, 0},1);
  fdscene.eofill(fdpath, fdpaint);
  return fdscene;
}

rvg::Window gradwindow(rvg::driver::Base &drv) {
    (void) drv;
    return rvg::Window{0,0,512,512};
}

int main(void) {
    using namespace rvg;
    driver::CPU cpu;
    auto scene = input::scene(cpu);
    //auto scene = gradscene(cpu);
    //scene.transform(xform::Rotation(25*math::to_rad()));
    auto window = input::window(cpu);
    //auto window = gradwindow(cpu);
    rvg::Viewport viewport{
        static_cast<int>(window.min.x),
        static_cast<int>(window.min.y),
        static_cast<int>(window.max.x),
        static_cast<int>(window.max.y)
    };
    cpu.render(
        scene,
        xform::Identity{},
        "output.png",
        viewport
    );
    return 0;
}
