#include <iostream>

#include "../driver/cuda.h"
#include "../math/util.h"

namespace input {
#include "../inputs/drops.h"
}

//namespace tiger {
//#include "../inputs/tiger.h"
//}

//namespace lion {
//#include "../inputs/lion.h"
//}


int main(void) {
    using namespace rvg;
    driver::CUDA cuda;
    auto scene = input::scene(cuda);
    scene.transform(xform::Rotation(25*math::to_rad()));
    auto window = input::window(cuda);
    rvg::Viewport viewport{
        static_cast<int>(window.min.x),
        static_cast<int>(window.min.y),
        static_cast<int>(window.max.x),
        static_cast<int>(window.max.y)
    };
    cuda.render(
        scene,
        xform::Identity{},
        "output.png",
        viewport
    );
    return 0;
}
