#include <cstdio>
#include <string>
#include <iostream>
#include <fstream>
#include <cerrno>

#include "../image/image.h"
#include "../image/concrete.h"
#include "../image/png.h"
#include "../util/base64.h"

using namespace rvg;

std::string load(const char *name) {
    std::ifstream in(name, std::ios::in | std::ios::binary);
    std::string contents;
    if (in) {
        in.seekg(0, std::ios::end);
        contents.resize(in.tellg());
        in.seekg(0, std::ios::beg);
        in.read(&contents[0], contents.size());
        in.close();
    }
    return contents;
}

int main(int argc, char *argv[]) {
    (void) argc;
    //FILE *in = fopen(argv[1], "rb");
    std::string in = load(argv[1]);
    image::Concrete img;
    image::png::load(in, img);
    //fclose(in);
    //FILE *out = fopen(argv[2], "wb");
    std::string out;
    image::png::store(out, img);
    //fclose(out);
    //std::cout << img;
    out = encode_base64(out);
    out = decode_base64(out);
    std::cout << out;
    return 0;
}
