#include <iostream>

#include "../paint/paint.h"

using namespace rvg;

int main(void) {

    paint::Ramp r{new paint::ramp::Base{SpreadMethod::pad,
        {{0, 1, 1, 0},
         {0.5, 0.5, 1, 0.1, 0.75},
         {1.f, 0.5, .5, 0.1}}
    }};

    Paint p{new paint::LinearGradient{
        r,
        r2::Point{0, 0}, r2::Point{1, 1}
    }};

    std::cout << p << std::endl;

    r.append({0, 2, 2, 3});
    r.set_spread(SpreadMethod::reflect);

    Paint q{new paint::RadialGradient{
        r,
        r2::Point{0, 0}, r2::Point{2, 2}, 3
    }};

    std::cout << q << std::endl;
    std::cout << p << std::endl;

    Paint o = q;

    std::cout << o << std::endl;

    return 0;
}
