#include <iostream>

#include "../path/path.h"
#include "../path/concrete.h"
#include "../math/util.h"

using namespace rvg;

int main(void) {
    Path u;

    Path p(new path::Concrete);

    p.append({{CommandType::move_to_abs, 0, 1},
       {CommandType::line_to_abs, 1, 0},
       {CommandType::line_to_abs, 0, 1},
       {CommandType::quad_to_abs, 2.5f, 2, 3, 1}});

    std::cout << p << std::endl;

    for (const auto &cmd: p) {
        std::cout << int(cmd.type) << std::endl;
    }

    Path q = p;

    p.append({CommandType::line_to_abs, 10, 15});
    p.append({CommandType::arc_to_abs, 5, 1, 1, 0, 10});

    Transform xf = xform::Rotation{10*math::to_rad()} * xform::Scale(-3,2);

    p.transform(xf);

    std::cout << p << std::endl;

    p.append({CommandType::line_to_abs, 10, 15});

    std::cout << p << std::endl;

    std::cout << q << std::endl;

    return 0;
}
