#include <iostream>
#include "xform/xform.h"

namespace xf = rvg::xform;

// identity -> others

void identity_identity()
{
    auto r = xf::Identity() * xf::Identity();
    std::cout << r << std::endl;
}

void identity_scale()
{
    auto r = xf::Identity() * xf::Scale(11,12);
    std::cout << r << std::endl;
}

void identity_rotation()
{
    auto r = xf::Identity() * xf::Rotation(M_PI/16);
    std::cout << r << std::endl;
}

void identity_translation()
{
    auto r = xf::Identity() * xf::Translation(11,12);
    std::cout << r << std::endl;
}

void identity_linear()
{
    auto r = xf::Identity() * xf::Linear(11,12,13,14);
    std::cout << r << std::endl;
}

void identity_affine()
{
    auto r = xf::Identity() * xf::Affine(11,12,13,14,15,16);
    std::cout << r << std::endl;
}

void identity_projective()
{
    auto r = xf::Identity() * xf::Projective(11,12,13,14,15,16,17,18,19);
    std::cout << r << std::endl;
}

// scale -> others

void scale_identity()
{
    auto r = xf::Scale(2,3) * xf::Identity();
    std::cout << r << std::endl;
}

void scale_scale()
{
    auto r = xf::Scale(2,3) * xf::Scale(11,12);
    std::cout << r << std::endl;
}

void scale_rotation()
{
    auto r = xf::Scale(2,3) * xf::Rotation(M_PI/16);
    std::cout << r << std::endl;
}

void scale_translation()
{
    auto r = xf::Scale(2,3) * xf::Translation(11,12);
    std::cout << r << std::endl;
}

void scale_linear()
{
    auto r = xf::Scale(2,3) * xf::Linear(11,12,13,14);
    std::cout << r << std::endl;
}

void scale_affine()
{
    auto r = xf::Scale(2,3) * xf::Affine(11,12,13,14,15,16);
    std::cout << r << std::endl;
}

void scale_projective()
{
    auto r = xf::Scale(2,3) * xf::Projective(11,12,13,14,15,16,17,18,19);
    std::cout << r << std::endl;
}

// rotation -> others

void rotation_identity()
{
    auto r = xf::Rotation(M_PI/8) * xf::Identity();
    std::cout << r << std::endl;
}

void rotation_scale()
{
    auto r = xf::Rotation(M_PI/8) * xf::Scale(11,12);
    std::cout << r << std::endl;
}

void rotation_rotation()
{
    auto r = xf::Rotation(M_PI/8) * xf::Rotation(M_PI/16);
    std::cout << r << std::endl;
}

void rotation_translation()
{
    auto r = xf::Rotation(M_PI/8) * xf::Translation(11,12);
    std::cout << r << std::endl;
}

void rotation_linear()
{
    auto r = xf::Rotation(M_PI/8) * xf::Linear(11,12,13,14);
    std::cout << r << std::endl;
}

void rotation_affine()
{
    auto r = xf::Rotation(M_PI/8) * xf::Affine(11,12,13,14,15,16);
    std::cout << r << std::endl;
}

void rotation_projective()
{
    auto r = xf::Rotation(M_PI/8) * xf::Projective(11,12,13,14,15,16,17,18,19);
    std::cout << r << std::endl;
}

// translation -> others

void translation_identity()
{
    auto r = xf::Translation(2,3) * xf::Identity();
    std::cout << r << std::endl;
}

void translation_scale()
{
    auto r = xf::Translation(2,3) * xf::Scale(11,12);
    std::cout << r << std::endl;
}

void translation_rotation()
{
    auto r = xf::Translation(2,3) * xf::Rotation(M_PI/16);
    std::cout << r << std::endl;
}

void translation_translation()
{
    auto r = xf::Translation(2,3) * xf::Translation(11,12);
    std::cout << r << std::endl;
}

void translation_linear()
{
    auto r = xf::Translation(2,3) * xf::Linear(11,12,13,14);
    std::cout << r << std::endl;
}

void translation_affine()
{
    auto r = xf::Translation(2,3) * xf::Affine(11,12,13,14,15,16);
    std::cout << r << std::endl;
}

void translation_projective()
{
    auto r = xf::Translation(2,3) * xf::Projective(11,12,13,14,15,16,17,18,19);
    std::cout << r << std::endl;
}

// linear -> others

void linear_identity()
{
    auto r = xf::Linear(2,3,4,5) * xf::Identity();
    std::cout << r << std::endl;
}

void linear_scale()
{
    auto r = xf::Linear(2,3,4,5) * xf::Scale(11,12);
    std::cout << r << std::endl;
}

void linear_rotation()
{
    auto r = xf::Linear(2,3,4,5) * xf::Rotation(M_PI/16);
    std::cout << r << std::endl;
}

void linear_translation()
{
    auto r = xf::Linear(2,3,4,5) * xf::Translation(11,12);
    std::cout << r << std::endl;
}

void linear_linear()
{
    auto r = xf::Linear(2,3,4,5) * xf::Linear(11,12,13,14);
    std::cout << r << std::endl;
}

void linear_affine()
{
    auto r = xf::Linear(2,3,4,5) * xf::Affine(11,12,13,14,15,16);
    std::cout << r << std::endl;
}

void linear_projective()
{
    auto r = xf::Linear(2,3,4,5) * xf::Projective(11,12,13,14,15,16,17,18,19);
    std::cout << r << std::endl;
}

// affine -> others

void affine_identity()
{
    auto r = xf::Affine(2,3,4,5,6,7) * xf::Identity();
    std::cout << r << std::endl;
}

void affine_scale()
{
    auto r = xf::Affine(2,3,4,5,6,7) * xf::Scale(11,12);
    std::cout << r << std::endl;
}

void affine_rotation()
{
    auto r = xf::Affine(2,3,4,5,6,7) * xf::Rotation(M_PI/16);
    std::cout << r << std::endl;
}

void affine_translation()
{
    auto r = xf::Affine(2,3,4,5,6,7) * xf::Translation(11,12);
    std::cout << r << std::endl;
}

void affine_linear()
{
    auto r = xf::Affine(2,3,4,5,6,7) * xf::Linear(11,12,13,14);
    std::cout << r << std::endl;
}

void affine_affine()
{
    auto r = xf::Affine(2,3,4,5,6,7) * xf::Affine(11,12,13,14,15,16);
    std::cout << r << std::endl;
}

void affine_projective()
{
    auto r = xf::Affine(2,3,4,5,6,7) * xf::Projective(11,12,13,14,15,16,17,18,19);
    std::cout << r << std::endl;
}

// affine -> others

void projective_identity()
{
    auto r = xf::Projective(2,3,4,5,6,7,8,9,10) * xf::Identity();
    std::cout << r << std::endl;
}

void projective_scale()
{
    auto r = xf::Projective(2,3,4,5,6,7,8,9,10) * xf::Scale(11,12);
    std::cout << r << std::endl;
}

void projective_rotation()
{
    auto r = xf::Projective(2,3,4,5,6,7,8,9,10) * xf::Rotation(M_PI/16);
    std::cout << r << std::endl;
}

void projective_translation()
{
    auto r = xf::Projective(2,3,4,5,6,7,8,9,10) * xf::Translation(11,12);
    std::cout << r << std::endl;
}

void projective_linear()
{
    auto r = xf::Projective(2,3,4,5,6,7,8,9,10) * xf::Linear(11,12,13,14);
    std::cout << r << std::endl;
}

void projective_affine()
{
    auto r = xf::Projective(2,3,4,5,6,7,8,9,10) * xf::Affine(11,12,13,14,15,16);
    std::cout << r << std::endl;
}

void projective_projective()
{
    auto r = xf::Projective(2,3,4,5,6,7,8,9,10) * xf::Projective(11,12,13,14,15,16,17,18,19);
    std::cout << r << std::endl;
}

void xform_function()
{
    xf::Transform a;
    a.translate_by(1,2);

    std::cout << a << std::endl;
}

void xform_function_composition()
{
    xf::Transform a;
    a.translate_by(0,0);
    a.rotate_by(M_PI);
    a.scale_by(2,4);
    a.translate_by(1,0);

    std::cout << a << std::endl;
}

void stack_composition_decrescent()
{
    auto d = xf::Affine(1,0,0,
                        0,1,0)
                *xf::Translation(1,3)
                *xf::Scale(2,3)
                *xf::Rotation(M_PI);

    std::cout << d << std::endl;
}

void stack_composition_crescent()
{
    auto d = xf::Rotation(M_PI)
        * xf::Scale(4,5)
        * xf::Translation(1,3)
        * xf::Projective(1,2,3,4,5,6,7,8,9);

    std::cout << d << std::endl;
}

void identity_comp_other_static()
{
    auto e = xf::Identity() * xf::Rotation(M_PI);

    std::cout << e << std::endl;
}

void other_static_comp_identity()
{
    auto e = xf::Rotation(M_PI) * xf::Identity();

    std::cout << e << std::endl;
}

void rhs_is_rvalue_static_xform()
{
    xf::Transform a(xf::Affine(1,0,0,0,1,0));

    // translation must not be cloned into heap
    a *= xf::Translation(3,4);

    std::cout << a << std::endl;
}

void ref_xform_comp_ref_identity_result_type()
{
    xf::Identity ident;
    xf::Identity &rident = ident;

    xf::Rotation rot(M_PI);

    auto e = rident * rot;

    std::cout << e << std::endl;
}

void ref_identity_comp_ref_xform_result_type()
{
    xf::Identity ident;
    xf::Identity &rident = ident;

    xf::Rotation rot(M_PI);

    auto e =  rot * rident;

    std::cout << e << std::endl;
}

void copy_on_write_not_shared()
{
    xf::Transform xf = xf::Linear(1,0,0,1);
    xf *= xf::Rotation(M_PI);

    std::cout << xf << std::endl;
}

void copy_on_write_shared()
{
    xf::Transform xf = xf::Linear(1,0,0,1);

    xf::Transform xf2 = xf;
    xf *= xf::Rotation(M_PI);

    std::cout << xf << std::endl;
}

void copy_on_write_shared_then_not_shared()
{
    xf::Transform xf = xf::Linear(1,0,0,1);

    {
        xf::Transform xf2 = xf;
        xf *= xf::Rotation(M_PI);
    }
    xf *= xf::Rotation(M_PI/2);

    std::cout << xf << std::endl;
}

void transform_comp_xform_one_virt_call()
{
    xf::Transform xf = xf::Linear(1,0,0,1);

    xf *= xf::Rotation(M_PI);

    std::cout << xf << std::endl;
}

void xform_comp_transform_one_virt_call()
{
    auto res = xf::Rotation(M_PI)*xf::Transform(xf::Linear(1,0,0,1));

    std::cout << res << std::endl;
}

void xform_comp_xform_two_virt_calls()
{
    xf::Transform xf1 = xf::Linear(1,0,0,1),
                  xf2 = xf::Rotation(M_PI);

    xf1 *= xf2;

    std::cout << xf1 << std::endl;
}

void parameter_aliasing()
{
    xf::Linear L(1,2,3,4);
    L *= L;
    std::cout << L << std::endl;

    xf::Affine A(1,2,3,4,5,6);
    A *= A;
    std::cout << A << std::endl;

    xf::Projective P(1,2,3,4,5,6,7,8,9);
    P *= P;
    std::cout << P << std::endl;
}

void comp_rvalue_optim()
{
    xf::Affine a(rand(),rand(),rand(),rand(),rand(),rand()), b(rand(),rand(),rand(),rand(),rand(),rand());

    a = a * b;

    a *= b;

    auto r = a * b;

    b = a * b;

    std::cout << b << std::endl;
}

#define CALL_TEST(x) else if(test == #x) x()

int main(int argc, char *argv[])
{
    if(argc != 2)
    {
        std::cerr << "wrong arguments" << std::endl;
        return -1;
    }

    std::string test = argv[1];

    if(false);
    CALL_TEST(identity_identity);
    CALL_TEST(identity_scale);
    CALL_TEST(identity_rotation);
    CALL_TEST(identity_translation);
    CALL_TEST(identity_linear);
    CALL_TEST(identity_affine);
    CALL_TEST(identity_projective);

    CALL_TEST(scale_identity);
    CALL_TEST(scale_scale);
    CALL_TEST(scale_rotation);
    CALL_TEST(scale_translation);
    CALL_TEST(scale_linear);
    CALL_TEST(scale_affine);
    CALL_TEST(scale_projective);

    CALL_TEST(rotation_identity);
    CALL_TEST(rotation_scale);
    CALL_TEST(rotation_rotation);
    CALL_TEST(rotation_translation);
    CALL_TEST(rotation_linear);
    CALL_TEST(rotation_affine);
    CALL_TEST(rotation_projective);

    CALL_TEST(translation_identity);
    CALL_TEST(translation_scale);
    CALL_TEST(translation_rotation);
    CALL_TEST(translation_translation);
    CALL_TEST(translation_linear);
    CALL_TEST(translation_affine);
    CALL_TEST(translation_projective);

    CALL_TEST(linear_identity);
    CALL_TEST(linear_scale);
    CALL_TEST(linear_rotation);
    CALL_TEST(linear_translation);
    CALL_TEST(linear_linear);
    CALL_TEST(linear_affine);
    CALL_TEST(linear_projective);

    CALL_TEST(affine_identity);
    CALL_TEST(affine_scale);
    CALL_TEST(affine_rotation);
    CALL_TEST(affine_translation);
    CALL_TEST(affine_linear);
    CALL_TEST(affine_affine);
    CALL_TEST(affine_projective);

    CALL_TEST(projective_identity);
    CALL_TEST(projective_scale);
    CALL_TEST(projective_rotation);
    CALL_TEST(projective_translation);
    CALL_TEST(projective_linear);
    CALL_TEST(projective_affine);
    CALL_TEST(projective_projective);

    CALL_TEST(xform_function);
    CALL_TEST(xform_function_composition);
    CALL_TEST(stack_composition_decrescent);
    CALL_TEST(stack_composition_crescent);
    CALL_TEST(identity_comp_other_static);
    CALL_TEST(other_static_comp_identity);
    CALL_TEST(rhs_is_rvalue_static_xform);
    CALL_TEST(ref_xform_comp_ref_identity_result_type);
    CALL_TEST(ref_identity_comp_ref_xform_result_type);
    CALL_TEST(copy_on_write_not_shared);
    CALL_TEST(copy_on_write_shared);
    CALL_TEST(copy_on_write_shared_then_not_shared);
    CALL_TEST(transform_comp_xform_one_virt_call);
    CALL_TEST(xform_comp_transform_one_virt_call);
    CALL_TEST(xform_comp_xform_two_virt_calls);
    CALL_TEST(parameter_aliasing);
    CALL_TEST(comp_rvalue_optim);

    else
    {
        std::cerr << "unknown test: " << test << std::endl;
        return -1;
    }

    return 0;
}
