#ifndef RVG_CLONEABLE_H
#define RVG_CLONEABLE_H

#include "refcnt.h"

namespace rvg
{

namespace detail
{
    class CloneableBase : public RefCounted
    {
    public:
        virtual ~CloneableBase() {}

        RefPtr<CloneableBase> clone() const
            { return RefPtr<CloneableBase>(do_clone()); }

    private:
        virtual CloneableBase *do_clone() const = 0;
    };
}

// Did not understand this at all???
template <class T>
class Cloneable : public detail::CloneableBase
{
public:
    RefPtr<T> clone() const
        { return static_pointer_cast<T>(detail::CloneableBase::clone()); }
};

// Eww... ??
#define IMPLEMENT_CLONEABLE(T) \
    public: \
        RefPtr<T> clone() const { return static_pointer_cast<T>(detail::CloneableBase::clone()); } \
    private: \
        T *do_clone() const override { return new T(*this); }

#define IMPLEMENT_ABSTRACT_CLONEABLE(T) \
    public: \
        RefPtr<T> clone() const \
            { return static_pointer_cast<T>(detail::CloneableBase::clone()); }

template<class T>
struct is_cloneable
    : std::is_base_of<detail::CloneableBase,
                      typename std::remove_reference<T>::type>
{
};

} // namespace rvg

#endif
