#ifndef QVG_XFORM_IDENTITY_H
#define QVG_XFORM_IDENTITY_H

#include "base.h"

namespace rvg { namespace xform
{

class Identity final : public BaseHelper<Identity>
{
public:
    static constexpr const char *name = "identity";

    Identity();
    Identity &operator *=(const Identity &) { return *this; }

private:
    virtual void do_print(std::ostream &out) const;

    r2::Point do_multiply(const r2::Point &p) const override;
    r2::Vector do_multiply(const r2::Vector &v) const override;
    r3::Point do_multiply(const r3::Point &p) const override;
};

}} // namespace rvg::xform

#include "identity.hpp"

#endif
