#ifndef QVG_XFORM_SCALE_H
#define QVG_XFORM_SCALE_H

#include "base.h"

namespace rvg { namespace xform
{

class Scale final : public BaseHelper<Scale>
{
public:
    static constexpr const char *name = "scale";

#if TRACE_XFORM
    Scale();
#else
    Scale() = default;
#endif

    // implicit conversion allowed
    Scale(const Identity &);

    Scale(float _sx, float _sy);

    float sx, sy;

    Scale &operator *=(float that);
    Scale &operator *=(const Identity &) { return *this; }
    Scale &operator *=(const Scale &that);

private:
    virtual void do_print(std::ostream &out) const;

    r2::Point do_multiply(const r2::Point &p) const override;
    r2::Vector do_multiply(const r2::Vector &v) const override;
    r3::Point do_multiply(const r3::Point &p) const override;
};

}} // namespace rvg::xform

#include "scale.hpp"

#endif
