#ifndef QVG_XFORM_TRANSLATION_H
#define QVG_XFORM_TRANSLATION_H

#include "base.h"

namespace rvg { namespace xform
{

class Translation final : public BaseHelper<Translation>
{
public:
    static constexpr const char *name = "translation";

#if TRACE_XFORM
    Translation();
#else
    Translation() = default;
#endif

    // implicit conversion allowed
    Translation(const Identity &);

    Translation(float _dx, float _dy);
    explicit Translation(const r2::Vector _v);
    float dx, dy;

    Translation &operator *=(const Identity &) { return *this; }
    Translation &operator *=(const Translation &that);

private:
    virtual void do_print(std::ostream &out) const;

    r2::Point do_multiply(const r2::Point &p) const override;
    r2::Vector do_multiply(const r2::Vector &v) const override;
    r3::Point do_multiply(const r3::Point &p) const override;
};

}} // namespace rvg::xform

#include "translation.hpp"

#endif
