local ctable = {
    "#b20400", "#eb7e6e", "#efa02b", "#fdd07d", "#b9cc12", "#517d14",
    "#2c5c12", "#5c6888", "#3a3d73", "#191140", "#8f8690"
}

ctable.ntable = {{178, 4, 0}, {235, 126, 110}, {239, 160, 43}, {253, 208, 125}, {185, 
  204, 18}, {81, 125, 20}, {44, 92, 18}, {92, 104, 136}, {58, 61, 
    115}, {25, 17, 64}, {143, 134, 144}}

ctable.get_color = function( table, n )
    if n <= #table then
        return table[((n-1) % #table) + 1]
    else
        local i = ((n-1) % #table) + 1
        local c1 = table.ntable[i]
        local c2 = table.ntable[i+1]
        local str = string.format("#%x%x%x", 0.5*(c1[1]+c2[1]), 0.5*(c1[2]+c2[2]), 0.5*(c1[3]+c2[3]) )
        return str
    end
end

--it's is simple for now, but we may want to
--change this rule for something like a shuffle, to
--avoid a rainbow effect
ctable.get_index = function( table, n )
    return ((n-1)%#table) + 1
end

ctable.size = function( table )
    return #table
end

return ctable
