local cmd = require "lua.command"
local table = {}

function print_table_level( file, table, pre )
    file:write(string.format("%s\ttime=%f,\n", pre, table.time )) 
    file:write(string.format("%s\tname=\"%s\",\n", pre, table.name )) 
    file:write(string.format("%s\tchildren={\n", pre)) 
    for k, v in pairs(table.children) do
        file:write(string.format("%s\t\t{\n", pre )) 
        print_table_level( file, v, pre.."\t\t" );
        file:write(string.format("%s\t\t},\n", pre )) 
    end
    file:write(string.format("%s\t},\n", pre )) 
end

table.store = function( name, hash, inputname, benchmark )
    local ret, msg = cmd.execute( string.format("ls data/%s/%s 2>/dev/null", name, hash) )
    if not ret then
        --print(string.format("\tcreating dir:%s/%s", name, hash)) 
        assert(cmd.execute(string.format("mkdir -p data/%s/%s", name, hash)))
    end
    local file = assert(io.open(string.format("data/%s/%s/%s.lua", name, hash, inputname), "w"))
    file:write("return { ")
    print_table_level( file, benchmark, "" )
    file:write(" }\n")
    file:close()
end

function dump_level( result, level, pre )
    print(string.format("%s [%d]%s %s", pre, result.level, result.name, result.time) )
    for k,v in pairs(result.children) do
        dump_level( v, level+1, pre.."  " )
    end
end

table.dump = function ( result )
    dump_level( result, 0, " " )
end

return table
