clear
reset
#unset key
#svgset terminal postscript enhanced color font "Arial,10" size 11,8.5
set terminal svg enhanced font "Arial,10" size 300,225
#set output 'plot.eps'
#set output  "output/rendering.eps"
set output  "output/rendering.svg"
#set terminal pngcairo  transparent enhanced font "arial,10" fontscale 1.0 size 1024, 768 
#set output 'plot.png'
set title "Rendering Benchmark"

# Make the x axis labels easier to read.
set xtics rotate by -45 nomirror
#set xlabel  "level #9"
set ylabel  "Time (s)"

# Select histogram data
set style data histogram

# Give the bars a plain fill pattern, and no line around them.
set style fill solid noborder
set style histogram rowstacked 
set boxwidth 0.6 relative

# Pick a few line colors
set style line 1 lt 1 lw 4 lc rgb "#b20400"
set style line 2 lt 1 lw 4 lc rgb "#eb7e6e"
set style line 3 lt 1 lw 4 lc rgb "#efa02b"
set style line 4 lt 1 lw 4 lc rgb "#fdd07d"
set style line 5 lt 1 lw 4 lc rgb "#b9cc12"
set style line 6 lt 1 lw 4 lc rgb "#517d14"
set style line 7 lt 1 lw 4 lc rgb "#2c5c12"
set style line 8 lt 1 lw 4 lc rgb "#5c6888"
set style line 9 lt 1 lw 4 lc rgb "#3a3d73"
set style line 10 lt 1 lw 4 lc rgb "#191140"
set style line 11 lt 1 lw 4 lc rgb "#8f8690"

plot newhistogram "run time(ms)", 'output/rendering.dat' u 2:xtic(1) ls 1 t 'TTraverse Shortcut Tree', '' u 3:xtic(1) ls 2 t 'Sorting results', '' u 4:xtic(1) ls 3 t 'Rasterization'
