local table = { }

table.figures = {
    { "inputs/performance/", "8-fixed-nostroke.rvg" },
    { "inputs/performance/", "contour0.rvg" },
    { "inputs/performance/", "lion.rvg" },
    { "inputs/performance/", "tiger.rvg" },
    { "inputs/performance/", "30000.rvg" },
}

table.open = function( input, drv )
    local fname = string.format("%s%s", input[1], input[2])
    local fd = dofile( fname )
    return true, "", { vp=fd.viewport(drv), win=fd.window(drv), scene=fd.scene(drv) }
end

table.resize = function( drv, width, scene, win, vp )
    local dim = { w=(vp.max.x - vp.min.x), h=(vp.max.y - vp.min.y) }
    local vp = drv.viewport(0, 0, width, width*dim.h/dim.w);
    local win = drv.window(0, 0, width, width*dim.h/dim.w);
    local nscene = scene:translate(-vp.min.x,-vp.min.y):scale(width/dim.w, width/dim.w)
    return nscene, win, vp
end

return table

