local benchmark = require "lua.benchmark"
local args = require "lua.args"
local params = require "lua.figures"
local project = require "lua.project"

print("copying modules... ")
assert( project.copy_modules( "master" ) )
local drvname = string.format("rvg10.cuda-%s", "master" )
local drv = require(drvname)

local argv = {
    "-kernel:42",
    "-bs3:0",
    "-iterations:20",
}
-- default configuration
local config = args.parse( argv )
print("32spp, box filtering")
benchmark.run( drv, "results_table1_32", params.inputs, config, "", "imgs/32/" )
---[[
print("32spp, box filtering with warp")
local i=1
for k, v in pairs( params.warps ) do
    local inp = { v }
    local argv = {
        "-kernel:43",
        "-bs3:0",
        "-iterations:20",
        v.srt
    }
    -- default configuration
    config = args.parse( argv )
    benchmark.run( drv, "results_table1_32", inp, config, "warp"..i, "imgs/32/" )
    i=i+1
end
--]]
--
local argv = {
    "-kernel:42",
    "-bs3:1",
    "-iterations:20",
}
-- default configuration
local config = args.parse( argv )
print("4x4x32spp, cardinal b-spline3 filtering")
benchmark.run( drv, "results_table1_4x4x32", params.inputs, config, "", "imgs/4x4x32/" )
---[[
local i=1
print("4x4x32spp, cardinal b-spline3 filtering with warp")
for k, v in pairs( params.warps ) do
    local inp = { v }
    local argv = {
        "-kernel:43",
        "-bs3:1",
        "-iterations:20",
        v.srt
    }
    -- default configuration
    config = args.parse( argv )
    benchmark.run( drv, "results_table1_4x4x32", inp, config, "warp"..i, "imgs/4x4x32/" )
    i=i+1
end
--]]
local argv = {
    "-kernel:42",
    "-bs3:0",
    "-iterations:20",
    "-nsamples:8",
}
-- default configuration
local config = args.parse( argv )
print("8spp, box filtering")
benchmark.run( drv, "results_table1_8", params.inputs, config, "", "imgs/8/" )
---[[
print("8spp, box filtering with warp")
local i=1
for k, v in pairs( params.warps ) do
    local inp = { v }
    local argv = {
        "-kernel:43",
        "-bs3:0",
        "-iterations:20",
        "-nsamples:8",
        v.srt
    }
    -- default configuration
    config = args.parse( argv )
    benchmark.run( drv, "results_table1_8", inp, config, "warp"..i, "imgs/8/" )
    i=i+1
end
--]]
