local color = require "lua.color"
local cmd = require "lua.command"

function create_plot_file( name, label )
    --local dir = "resolution"
    local dir = "."
    cmd.dir_exists( dir, true )
    local fd = assert(io.open(string.format("%s/%s.gnuplot", dir, name), "w"))
    local tpl = assert(io.open("lua/resolution/plot.tpl", "r"))
    if tpl then
        for line in tpl:lines() do
            --print(name, size, line)
            if line:find("#PLOT") then
                --fd:write(string.format("plot 'output/resolution/%s.dat' u 1:2 with linespoints ls 1 t '32', '' u 1:3 with linespoints ls 5 t '4x4x32'", name))
                fd:write(string.format("plot '%s.dat' u 1:2 with linespoints ls 1 t '32', '' u 1:3 with linespoints ls 5 t '4x4x32'", name))
            elseif line:find("#LABEL") then
                fd:write(string.format("set xlabel  \"%s\"\n", label))
            elseif line:find("#OUTPUT") then
                --fd:write(string.format("set output  \"%s/%s.eps\"\n", dir, name))
                --fd:write(string.format("set output  \"out/%s.svg\"\n", name))
                fd:write(string.format("set output  \"%s.png\"\n", name))
            elseif line:find("#LSTYLE") then
                for i=1,2*color:size()-1 do
                    local str = "set style line %d lt 1 lw 4 lc rgb \"%s\"\n"
                    fd:write( str:format(i, color:get_color(i)) )
                end
            else
                fd:write( line.."\n" )
            end
        end
    end
    fd:close()
    tpl:close()
end

function create_plot_file_all( name, label, figs )
    --local dir = "resolution"
    local dir = "."
    cmd.dir_exists( dir, true )
    local fd = assert(io.open(string.format("%s/%s.gnuplot", dir, name), "w"))
    local tpl = assert(io.open("lua/resolution/plot.tpl", "r"))
    if tpl then
        for line in tpl:lines() do
            --print(name, size, line)
            if line:find("#PLOT") then
                fd:write(string.format("plot "))
                local i = 1
                for _, v in pairs(figs) do
                    local com = ", "
                    if i == #figs then com = "" end
                    --fd:write(string.format("'output/resolution/%s.dat' u 1:%d with linespoints ls %d t '%s'%s", name, i+1, i, v, com))
                    fd:write(string.format("'%s.dat' u 1:%d with linespoints ls %d t '%s'%s", name, i+1, i, v, com))
                    i = i + 1
                end
                fd:write(string.format("\n"))
            elseif line:find("#LABEL") then
                fd:write(string.format("set xlabel  \"%s\"\n", label))
            elseif line:find("#OUTPUT") then
                --fd:write(string.format("set output  \"%s/%s.eps\"\n", dir, name))
                --fd:write(string.format("set output  \"out/%s.svg\"\n", name))
                fd:write(string.format("set output  \"%s.png\"\n", name))
            elseif line:find("#LSTYLE") then
                for i=1,2*color:size()-1 do
                    local str = "set style line %d lt 1 lw 4 lc rgb \"%s\"\n"
                    fd:write( str:format(i, color:get_color(i)) )
                end
            else
                fd:write( line.."\n" )
            end
        end
    end
    fd:close()
    tpl:close()
end
