local report = require "lua.report"
require "lua.resolution.create_report_file"
local cmd = require "lua.command"
local input = require "lua.resolution.inputs"

-- default configuration
local min=256
local max=2048
local num=10
local size = {}
for i=0,num do
    local width = min + i * (max-min)/num
    size[#size+1] = math.floor(width*width)
end
--
local str = "%s.dat"
local results_512 = report.load_data( "resolution_4x4x32" )
local res = { }
local all = { }
local nums = { }
for k, v in pairs( results_512 ) do
    res[k] = { }
    local time = {}
    local index = { }
    for num, l in pairs( v ) do
        time[tonumber(num)] = l.master.children[2].children[1].time*1000
        local nnn = tonumber(num)
        nums[nnn] = 1
        index[#index+1] = nnn
        if not all[nnn] then all[nnn] = { } end
        all[nnn][k] = l.master.children[2].children[1].time*1000
    end
    table.sort( index )
    for m, n in pairs( index ) do
        if not res[k][n] then res[k][n] = {} end
        res[k][n]["512"] = time[n]
    end
end
--
-- sort all number of pixels
local index = {}
for k, _ in pairs( nums ) do
    index[#index+1] = k
end
table.sort( index )
--

local fdall = assert( io.open(str:format("all512"), "w"))
for _, v in pairs( index ) do
    print( v )
    fdall:write(string.format("%d\t", v))
    for _, n in pairs( input.order ) do
        print( n, all[v][n] )
        fdall:write(string.format("%.02f\t", all[v][n]))
    end
    fdall:write("\n")
end
fdall:close()
create_plot_file_all( "all512", "All 4x4x32", input.labels )
--cmd.execute(string.format("gnuplot resolution/%s.gnuplot", "all512"))

